package info.textgrid.middleware;

/**
 * <p>
 * Collection of values never changing its content.
 * </p>
 * 
 * @author Maximilian Brodhun, SUB Göttingen
 */

public final class OaipmhConstants {

  // **
  // GENERAL CONSTANTS
  // **

  public static final String URI_IDENTIIER_TYPE = "URI";

  // Metadata Prefixes
  public static final String METADATA_IDIOM_PREFIX = "oai_idiom_mets";
  public static final String METADATA_OPENAIRE_PREFIX = "oai_datacite";

  // Error String Constants
  public static final String OAI_BAD_ARGUMENT = "BadArgument";
  public static final String OAI_METADATA_FORMAT_ERROR = "FormatError";
  public static final String OAI_NO_RECORD_MATCH = "RecordMatchError";
  public static final String OAI_NO_SET_HIERARCHY = "SetHierarchyError";
  public static final String OAI_BAD_RESUMPTION_TOKEN = "badResumptionToken";
  public static final String OAI_ID_DOES_NOT_EXIST = "idDoesNotExist";
  public static final String OAI_VERB_ERROR = "badVerb";

  // **
  // DARIAH CONSTANTS
  // **

  public static final String REPOSITORY_BASEURL = "repository.de.dariah.eu";

  // For testing only.
  // TODO Run tests with real configuration, we changed a lot currently!
  public static final String TEST_DARIAH_ITEM_IDENTIFIER_PREFIX = "hdl:";
  public static final String TEST_DARIAH_COLLECTIONREGISTRY_PREFIX = "dariah:collection:";
  public static final String TEST_DARIAH_COLLECTION_MIMETYPE =
      "text/vnd.dariah.dhrep.collection+turtle";

  // DARIAH Metadata Fields for OAI-PMH Request (Mapping to DC)
  public static final String TEST_DARIAH_CREATED = "descriptiveMetadata.dc:date";
  public static final String TEST_DARIAH_FORMAT = "descriptiveMetadata.dc:format";
  public static final String TEST_DARIAH_IDENTIFIER = "administrativeMetadata.dcterms:identifier";
  public static final String[] TEST_DARIAH_FIELDS =
      {"descriptiveMetadata.dc:contributor", "descriptiveMetadata.dc:coverage",
          "administrativeMetadata.dcterms:created", "administrativeMetadata.dcterms:modified",
          "descriptiveMetadata.dc:description", "descriptiveMetadata.dc:format",
          "descriptiveMetadata.dc:identifier", "descriptiveMetadata.dc:language",
          "descriptiveMetadata.dc:publisher", "descriptiveMetadata.dc:relation",
          "descriptiveMetadata.dc:rights", "descriptiveMetadata.:source",
          "descriptiveMetadata.dc:subject", "descriptiveMetadata.dc:title",
          "descriptiveMetadata.dc:type", "administrativeMetadata.dcterms:identifier"};

  // String Arrays to define which TextGrid fields belongs to the regarding DC fields
  public static final String[] TEST_DARIAH_CONTRIBUTOR_LIST =
      {"descriptiveMetadata.dc:contributor"};
  public static final String[] TEST_DARIAH_COVERAGE_LIST = {"descriptiveMetadata.dc:coverage"};
  public static final String[] TEST_DARIAH_CREATOR_LIST = {"descriptiveMetadata.dc:cretor"};
  public static final String[] TEST_DARIAH_DATE_LIST = {"administrativeMetadata.dcterms:modified"};
  public static final String[] TEST_DARIAH_DESCRIPTION_LIST =
      {"descriptiveMetadata.dc:description"};
  public static final String[] TEST_DARIAH_FORMAT_LIST = {"descriptiveMetadata.dc:format"};
  public static final String[] TEST_DARIAH_IDENTIFIER_LIST = {"descriptiveMetadata.dc:identifier"};
  public static final String[] TEST_DARIAH_LANGUAGE_LIST = {"descriptiveMetadata.dc:language"};
  public static final String[] TEST_DARIAH_PUBLISHER_LIST = {"descriptiveMetadata.dc:publisher"};
  public static final String[] TEST_DARIAH_RELATIONS_LIST = {"descriptiveMetadata.dc:relation"};
  public static final String[] TEST_DARIAH_RIGHTS_LIST = {"descriptiveMetadata.dc:rights"};
  public static final String[] TEST_DARIAH_SOURCE_LIST = {"descriptiveMetadata.dc:source"};
  public static final String[] TEST_DARIAH_SUBJECT_LIST = {"descriptiveMetadata.dc:subject"};
  public static final String[] TEST_DARIAH_TITLE_LIST = {"descriptiveMetadata.dc:title"};
  public static final String[] TEST_DARIAH_TYPE_LIST = {"descriptiveMetadata.dc:type"};
  public static final String[] TEST_DARIAH_IDENTIFIER_LIST_FIELDS =
      {"administrativeMetadata.dcterms:identifier", "administrativeMetadata.dcterms:modified",
          "descriptiveMetadata.dc:identifier", "descriptiveMetadata.dc:date",
          "descriptiveMetadata.dc:format"};
  public static final String TEST_DARIAH_RANGE_FIELD = "administrativeMetadata.dcterms:modified";
  public static final String TEST_DARIAH_MODIFIED_FIELD = "administrativeMetadata.dcterms:modified";
}
