package info.textgrid.middleware.test;

import java.text.ParseException;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;
import info.textgrid.middleware.IdentifierListDelivererDC;
import info.textgrid.middleware.IdentifierListDelivererDatacite;
import info.textgrid.middleware.IdentifierListDelivererIdiom;
import info.textgrid.middleware.MetadataFormatListDelivererDH;
import info.textgrid.middleware.MetadataFormatListDelivererInterface;
import info.textgrid.middleware.OaipmhConstants;
import info.textgrid.middleware.OaipmhElasticSearchClient;
import info.textgrid.middleware.OaipmhImpl;
import info.textgrid.middleware.OaipmhUtilities;
import info.textgrid.middleware.RecordDelivererDC;
import info.textgrid.middleware.RecordDelivererDatacite;
import info.textgrid.middleware.RecordDelivererIdiom;
import info.textgrid.middleware.RecordListDelivererDC;
import info.textgrid.middleware.RecordListDelivererDatacite;
import info.textgrid.middleware.RecordListDelivererIdiom;
import info.textgrid.middleware.RepIdentification;
import info.textgrid.middleware.SetListDeliverer;
import info.textgrid.middleware.common.TextGridMimetypes;
import info.textgrid.middleware.oaipmh.DeletedRecordType;
import info.textgrid.middleware.oaipmh.GranularityType;

/**
 * FIXME: Add documentation how to use this class, use SSH tunnel?
 */
@Ignore
public class TestDHOaipmhLocally {

  public static OaipmhElasticSearchClient oaiEsClient;

  private static RecordDelivererDC record;
  private static RecordListDelivererDC recordList;
  private static IdentifierListDelivererDC identifierList;
  private static MetadataFormatListDelivererInterface metadataFormatList =
      new MetadataFormatListDelivererDH();
  private static SetListDeliverer setListDARIAH = new SetListDeliverer(false, true);

  // private static OpenAireRecord openAireRecord;
  private static RecordDelivererDatacite recordDATACITE;
  // private static OpenAireRecordList openAireRecordList;
  private static RecordListDelivererDatacite recordListDATACITE;
  // private static OpenAireIdentifierList openAireIdentifierList;
  private static IdentifierListDelivererDatacite identifierListDATACITE;
  // private static IdiomImages idiomImages;
  private DeletedRecordType deletedRecordType = DeletedRecordType.NO;
  private GranularityType granularityType = GranularityType.YYYY_MM_DD_THH_MM_SS_Z;
  private RepIdentification rep = new RepIdentification("DARIAH-DE Repository",
      "https://trep.de.dariah.eu", this.deletedRecordType, "2011-06-11T02:32:40Z",
      this.granularityType, "2.0", "funk@sub.uni-goettingen.de");

  /**
   * FIXME: it should not be necessary to put idiom record variables for a DARIAH test case
   */
  private static RecordDelivererIdiom recordIDIOM;
  private static RecordListDelivererIdiom recordListIDIOM;
  private static IdentifierListDelivererIdiom identifierListIDIOM =
      new IdentifierListDelivererIdiom(true, false);

  private OaipmhImpl request =
      new OaipmhImpl(this.rep,
          TestDHOaipmhLocally.record,
          TestDHOaipmhLocally.recordIDIOM,
          TestDHOaipmhLocally.recordDATACITE,
          TestDHOaipmhLocally.recordList,
          TestDHOaipmhLocally.recordListIDIOM,
          TestDHOaipmhLocally.recordListDATACITE,
          TestDHOaipmhLocally.metadataFormatList,
          TestDHOaipmhLocally.setListDARIAH,
          TestDHOaipmhLocally.identifierList,
          TestDHOaipmhLocally.identifierListIDIOM,
          // OaiPmhTestDH.openAireIdentifierList);
          TestDHOaipmhLocally.identifierListDATACITE
      // TestDHOaipmhLocally.idiomImages
      );

  OaipmhUtilities settings = new OaipmhUtilities();

  /**
   * @throws Exception
   */
  @BeforeClass
  public static void setUp() throws Exception {
    int[] ports = new int[] {9202};
    oaiEsClient = new OaipmhElasticSearchClient("localhost", ports, 100);
    oaiEsClient.setEsIndex("dariah-public");
    oaiEsClient.setEsType("metadata");

    record = new RecordDelivererDC(false, true);
    record.setOaiEsClient(oaiEsClient);
    record.setWorkFields(OaipmhConstants.TEST_DARIAH_FIELDS);
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testGetRequestIdentify() throws ParseException {
    System.out.println("Test for the verb \"Identify\" with succesfull response");
    String r = this.request.getRequest("Identify", "", "", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testGetRequestGetRecordDariah() throws ParseException {

    TestDHOaipmhLocally.record.setContributor(OaipmhConstants.TEST_DARIAH_CONTRIBUTOR_LIST);
    TestDHOaipmhLocally.record.setCoverage(OaipmhConstants.TEST_DARIAH_COVERAGE_LIST);
    TestDHOaipmhLocally.record.setCreator(OaipmhConstants.TEST_DARIAH_CREATOR_LIST);
    TestDHOaipmhLocally.record.setDates(OaipmhConstants.TEST_DARIAH_DATE_LIST);
    TestDHOaipmhLocally.record.setDescriptions(OaipmhConstants.TEST_DARIAH_DESCRIPTION_LIST);
    TestDHOaipmhLocally.record.setFormats(OaipmhConstants.TEST_DARIAH_FORMAT_LIST);
    TestDHOaipmhLocally.record.setIdentifiers(OaipmhConstants.TEST_DARIAH_IDENTIFIER_LIST);
    TestDHOaipmhLocally.record.setLanguages(OaipmhConstants.TEST_DARIAH_LANGUAGE_LIST);
    TestDHOaipmhLocally.record.setPublishers(OaipmhConstants.TEST_DARIAH_PUBLISHER_LIST);
    TestDHOaipmhLocally.record.setRelations(OaipmhConstants.TEST_DARIAH_RELATIONS_LIST);
    TestDHOaipmhLocally.record.setRights(OaipmhConstants.TEST_DARIAH_RIGHTS_LIST);
    TestDHOaipmhLocally.record.setSources(OaipmhConstants.TEST_DARIAH_SOURCE_LIST);
    TestDHOaipmhLocally.record.setSubjects(OaipmhConstants.TEST_DARIAH_SUBJECT_LIST);
    TestDHOaipmhLocally.record.setTitles(OaipmhConstants.TEST_DARIAH_TITLE_LIST);
    TestDHOaipmhLocally.record.setTypes(OaipmhConstants.TEST_DARIAH_TYPE_LIST);
    TestDHOaipmhLocally.record.setFields(OaipmhConstants.TEST_DARIAH_FIELDS);
    TestDHOaipmhLocally.record.setFormatField(OaipmhConstants.TEST_DARIAH_FORMAT);
    TestDHOaipmhLocally.record.setFormatToFilter("metadata");
    TestDHOaipmhLocally.record
        .setDateOfObjectCreation(OaipmhConstants.TEST_DARIAH_MODIFIED_FIELD);
    TestDHOaipmhLocally.record
        .setRepositoryObjectURIPrefix(OaipmhConstants.TEST_DARIAH_ITEM_IDENTIFIER_PREFIX);
    TestDHOaipmhLocally.record.setIdentifierField("administrativeMetadata.dcterms:identifier");

    System.out.println("Test for the verb \"GetRecord\" for DARIAH with succesfull response");
    String p = this.request.getRequest("GetRecord", "hdl:21.T11991/0000-0005-E1AA-D", "oai_dc", "",
        "", "", "");
    System.out.println(p);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListRecordsDariah() throws ParseException {

    TestDHOaipmhLocally.recordList.setContributors(OaipmhConstants.TEST_DARIAH_CONTRIBUTOR_LIST);
    TestDHOaipmhLocally.recordList.setCoverages(OaipmhConstants.TEST_DARIAH_COVERAGE_LIST);
    TestDHOaipmhLocally.recordList.setCreators(OaipmhConstants.TEST_DARIAH_CREATOR_LIST);
    TestDHOaipmhLocally.recordList.setDates(OaipmhConstants.TEST_DARIAH_DATE_LIST);
    TestDHOaipmhLocally.recordList.setDescriptions(OaipmhConstants.TEST_DARIAH_DESCRIPTION_LIST);
    TestDHOaipmhLocally.recordList.setFormats(OaipmhConstants.TEST_DARIAH_FORMAT_LIST);
    TestDHOaipmhLocally.recordList.setIdentifiers(OaipmhConstants.TEST_DARIAH_IDENTIFIER_LIST);
    TestDHOaipmhLocally.recordList.setLanguages(OaipmhConstants.TEST_DARIAH_LANGUAGE_LIST);
    TestDHOaipmhLocally.recordList.setPublishers(OaipmhConstants.TEST_DARIAH_PUBLISHER_LIST);
    TestDHOaipmhLocally.recordList.setRelations(OaipmhConstants.TEST_DARIAH_RELATIONS_LIST);
    TestDHOaipmhLocally.recordList.setRights(OaipmhConstants.TEST_DARIAH_RIGHTS_LIST);
    TestDHOaipmhLocally.recordList.setSources(OaipmhConstants.TEST_DARIAH_SOURCE_LIST);
    TestDHOaipmhLocally.recordList.setSubjects(OaipmhConstants.TEST_DARIAH_SUBJECT_LIST);
    TestDHOaipmhLocally.recordList.setTitles(OaipmhConstants.TEST_DARIAH_TITLE_LIST);
    TestDHOaipmhLocally.recordList.setTypes(OaipmhConstants.TEST_DARIAH_TYPE_LIST);
    TestDHOaipmhLocally.recordList.setFormatField(OaipmhConstants.TEST_DARIAH_FORMAT);
    TestDHOaipmhLocally.recordList.setDateOfObjectCreation(OaipmhConstants.TEST_DARIAH_CREATED);
    TestDHOaipmhLocally.recordList.setRangeField(OaipmhConstants.TEST_DARIAH_MODIFIED_FIELD);
    TestDHOaipmhLocally.recordList
        .setDateOfObjectCreation(OaipmhConstants.TEST_DARIAH_RANGE_FIELD);
    TestDHOaipmhLocally.recordList.setIdentifierField(OaipmhConstants.TEST_DARIAH_IDENTIFIER);
    TestDHOaipmhLocally.recordList.setFormatToFilter(TextGridMimetypes.DARIAH_COLLECTION);
    TestDHOaipmhLocally.recordList.setModifiedField(OaipmhConstants.TEST_DARIAH_MODIFIED_FIELD);
    TestDHOaipmhLocally.recordList
        .setRelationToFurtherMetadataObject("descriptiveMetadata.dc:relation");
    TestDHOaipmhLocally.recordList.setSearchResponseSize(100);

    String r = this.request.getRequest("ListRecords", "", "oai_dc", "21.T11991/0000-0003-718E-E",
        "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListSetsDARIAH() throws ParseException {

    TestDHOaipmhLocally.setListDARIAH.setFormatField(OaipmhConstants.TEST_DARIAH_FORMAT);
    TestDHOaipmhLocally.setListDARIAH
        .setFormatToFilter(OaipmhConstants.TEST_DARIAH_COLLECTION_MIMETYPE);
    TestDHOaipmhLocally.setListDARIAH.setIdentifierField(OaipmhConstants.TEST_DARIAH_IDENTIFIER);
    TestDHOaipmhLocally.setListDARIAH
        .setRepositoryObjectURIPrefix(OaipmhConstants.TEST_DARIAH_ITEM_IDENTIFIER_PREFIX);
    TestDHOaipmhLocally.setListDARIAH
        .setIdentifierField("administrativeMetadata.dcterms:identifier");
    TestDHOaipmhLocally.setListDARIAH
        .setSpecFieldPrefix(OaipmhConstants.TEST_DARIAH_COLLECTIONREGISTRY_PREFIX);
    String r = this.request.getRequest("ListSets", "", "", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListIdentifiersDARIAH() throws ParseException {

    TestDHOaipmhLocally.identifierList.setFieldForRange(OaipmhConstants.TEST_DARIAH_RANGE_FIELD);
    TestDHOaipmhLocally.identifierList
        .setIdentifierListFields(OaipmhConstants.TEST_DARIAH_IDENTIFIER_LIST_FIELDS);
    TestDHOaipmhLocally.identifierList
        .setDateOfObjectCreation("administrativeMetadata.dcterms:modified");
    TestDHOaipmhLocally.identifierList
        .setRepositoryObjectURIPrefix(OaipmhConstants.TEST_DARIAH_ITEM_IDENTIFIER_PREFIX);
    TestDHOaipmhLocally.identifierList
        .setIdentifierField("administrativeMetadata.dcterms:identifier");
    TestDHOaipmhLocally.identifierList.setSearchResponseSize("100");
    String r = this.request.getRequest("ListIdentifiers", "", "oai_dc", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

}
